require 'set'

# le邩
$PERMIT_DUPLICATE = false if !$PERMIT_DUPLICATE

# ̃NX`
# ̓NXȂ̂ŕEl̕ҏWɂ͒ӂׂ
Condition = Struct.new(:char, :digit)

# NoGood̏Wi[
class NoGoodSet
	def initialize(hashes)
		@coreset = Set.new # ׂĂ̏
		@hashes = hashes # ̃nbVz
		@nonzero = _make_nonzero_list # [ł͂Ȃ̔z
	end

	# NoGoodǂ𔻒肷
	# NoGoodłtrueAłȂfalseԂ
	def nogood?(condset)
		# ȂΓRtrue
		if condset.count == 0
			return false
		end

		# ܂IȏW̖

		# [ł͂Ȃ[
		@nonzero.each do |c|
			if condset.find {|v| v.char == c && v.digit == 0}
#				puts "Nogood: <#{c} = 0: First letter>"
				return true 
			end
		end

		# ̋Lɂ͕ʂ̒l͓Ȃ
		arr = condset.sort_by{|c| c.char}
		tmp = arr[0]
		for i in 1...arr.length
			return true if arr[i].char == tmp.char
			tmp = arr[i]
		end

		# ͓xȂ
		if !$PERMIT_DUPLICATE
			arr.sort_by!{|c| c.digit}
			tmp = arr[0]
			for i in 1...arr.length
				return true if arr[i].digit == tmp.digit
				tmp = arr[i]
			end
		end

		# ׂĂ̏WЂƂЂƂׁAǂꂩ1łcondset̃TuZbgłꍇNoGoodɂȂ
		# condset̕WNGł΁AcondsetNG낤?
		@coreset.each do |c|
			if c.subset?(condset)
#				puts "Nogood: subset of Nogood"
#				p c
#				puts "--->"
#				p condset
				return true 
			end
		end

		# vZĂ݂Ė炩ɕsȂ玀ʂȂȂ!
		# ̂Ƃ͔񎩖Ȃ̂Ŏɓo^
		if _invalid_calc?(condset)
			add(condset)
#			puts "Nogood: wrong sum"
#			p condset
			return true
		end

		# ׂOKłfalse
		false
	end

	def add(condset)
		# condsetڂ͍̂폜
		@coreset.delete_if do |c|
			c.superset?(condset)
		end

		@coreset << condset
	end

	def count
		@coreset.count
	end

	private

	# ϐƂɐl𓱂
	def _get_val(str, condset)
		strret = ''
		str.each_char do |chr|
			f = condset.find {|c| c.char == chr}
			strret += f.digit.to_s if f
			strret += chr unless f
		end
		strret.to_i
	end

	# ؍\vZ
	def _tree_calc(root, condset)
		if root.is_a?(Value)
			_get_val(root.str, condset)
		else
			case root.str
			when '+'
				_tree_calc(root.left_node, condset) + _tree_calc(root.right_node, condset)
			when '-'
				_tree_calc(root.left_node, condset) - _tree_calc(root.right_node, condset)
			when '*'
				_tree_calc(root.left_node, condset) * _tree_calc(root.right_node, condset)
			when '/'
				_tree_calc(root.left_node, condset) / _tree_calc(root.right_node, condset)
			when '%'
				_tree_calc(root.left_node, condset) % _tree_calc(root.right_node, condset)
			end
		end
	end

	# 2ZłĉZq+-*̏ꍇ̂݁ǍvZ邱Ƃł̂ŁAŔf
	# ł\falseAȂtrue
	def _binary_operation_solver(hash, condset)
		if hash[:tree].is_a?(Operator) && hash[:tree].left_node.is_a?(Value) && hash[:tree].right_node.is_a?(Value) && '+-*'.index(hash[:tree].str)
			left = hash[:tree].left_node.str
			right = hash[:tree].right_node.str
			value = hash[:value]
			cp = []
			[left, right, value].each do |s|
				r = 0
				s.reverse.each_char do |chr|
					if chr =~ /\d/ || condset.find {|c| c.char == chr}
						r += 1
					else
						break
					end
				end
				cp << r
			end
			can_calc = cp.min # vZĔfł錅
			return false if can_calc == 0

			lt = _get_val(left[left.length - can_calc ... left.length], condset)
			rt = _get_val(right[right.length - can_calc ... right.length], condset)
			vt = _get_val(value[value.length - can_calc ... value.length], condset)
			vtr = 0 # ƉEvZ

			case hash[:tree].str
			when '+'
				vtr = lt + rt
			when '-'
				vtr = lt - rt
			when '*'
				vtr = lt * rt
			end

			# vt  vtr ̉can_calcΐ\̂false
			vt != vtr % (10**can_calc)
		else
			false
		end
	end

	# hashesɂvZɂĂ̌vZȂtrueAł\falseԂ
	def _invalid_calc?(condset)
		@hashes.each do |h|
			all_valiable = true
			h[:value_list].each do |v|
				all_valiable &&= !!(condset.find {|c| c.char == v})
			end

			# ׂĂ̕ϐĂꍇ̂ݔ肷
			if all_valiable
				left = _tree_calc(h[:tree], condset)
				right = _get_val(h[:value], condset)
				return true if left != right
			else
				# 2vZŉip^[
				return true if _binary_operation_solver(h, condset)
			end
		end

		# ׂOKłfalse
		false
	end

	def _make_nonzero_list_str(str)
		if str.length >= 2 && !('0123456789'.index(str[0]))
			[str[0]]
		else
			[]
		end
	end

	def _make_nonzero_list_tree(tree)
		if tree.is_a?(Value)
			_make_nonzero_list_str(tree.str)
		else
			_make_nonzero_list_tree(tree.left_node) | _make_nonzero_list_tree(tree.right_node)
		end
	end

	def _make_nonzero_list
		ret = []
		@hashes.each do |h|
			ret |= _make_nonzero_list_tree(h[:tree]) | _make_nonzero_list_str(h[:value])
		end
		ret
	end
end

# bW`
# ۂɍ\zƔɑ傫ȔbWƂȂĂ܂߁Aۂɂ̓ANZX邽тɕKvȕ𓮓Iɐ
class Lattice
	def initialize(hashes, premises = Set.new, value_list = nil)
		@premises = premises
		@nowptr_cond = nil
		@hashes = hashes
		if !value_list
			@value_list = _value_list_with_point(@hashes)
		else
			@value_list = value_list
		end
	end

	# ݂̃|WVĂ̏WLatticeԂ
	# |WVȂȂnilԂ
	def read
		if @nowptr_cond
			Lattice.new(@hashes, @premises | [@nowptr_cond], @value_list)
		else
			nil
		end
	end

	# |WVɈړÃ|WVĂ̏WLatticeԂ
	# łɏI[ɂꍇɂnilԂ
	# Ȃ݂͌̃m[h1̃m[hłƍlĂ
	def next
		while _next_cond && @premises.include?(@nowptr_cond)
		end
		read
	end

	# |WV[ɖ߂
	def seek_origin
		@nowptr_cond = nil
	end

	# ̃m[h̑O
	# j󂳂Ȃ悤ɃfB[vRs[Ă
	def premises
		Set.new @premises.to_a.collect{|c| c.dup}
	end

	def premises_count
		@premises.count
	end

	def nogood?(ngset)
		ngset.nogood?(@premises)
	end

	def pr
		@premises.each {|v| print("#{v.char}=#{v.digit}  ")}
		print "\n"
	end

	private

	# @nowptr_cond1߂
	# ̃RfBVOɓĂ邩ǂ͖Ȃ
	# ȂnilԂ@nilł΍ŏ̃AԂ
	def _next_cond
		if @nowptr_cond
			if @nowptr_cond.digit == 9
				char = @value_list[@value_list.index(@nowptr_cond.char) + 1]
				if char
					@nowptr_cond = Condition.new(char, 0)
				else
					@nowptr_cond = nil
				end
			else
				@nowptr_cond = Condition.new(@nowptr_cond.char, @nowptr_cond.digit + 1)
			end
		else
			@nowptr_cond = Condition.new(@value_list[0], 0)
		end
		@nowptr_cond
	end

	def _value_list_with_point_str(str, rethash)
		for i in 0...str.length
			next if '0123456789'.index(str[i])
			pnt = 1.0 / 2**(str.length - i - 1)
			if rethash[str[i]]
				rethash[str[i]] += pnt
			else
				rethash[str[i]] = pnt
			end
		end
	end

	def _value_list_with_point_tree(root, rethash)
		if root.is_a?(Value)
			_value_list_with_point_str(root.str, rethash)
		elsif root.is_a?(Operator)
			_value_list_with_point_tree(root.left_node, rethash)
			_value_list_with_point_tree(root.right_node, rethash)
		end
	end

	# Hashz̒ŎgĂSϐԂATDx̍̂OɂzԂ
	def _value_list_with_point(hashes)
		rethash = {}
		hashes.each do |h|
			_value_list_with_point_tree(h[:tree], rethash)
			_value_list_with_point_str(h[:value], rethash)
		end
		rethash.sort_by{|k,v| -v}.collect{|k,v| k}
	end
end
